<?php 
/*******************************************************************
 *			
 * 			Fichier			:	config.php 
 * 			Cr le			:	14 juillet 2002 
 * 			Dernire modif	:	16 avril 2003 
 * 			Email			:	wascripts@phpcodeur.net 
 * 
 * 				Copyright  2002-2003 phpCodeur
 * 
 *******************************************************************/

/*******************************************************************
 *  This program is free software; you can redistribute it and/or 
 * 	modify it under the terms of the GNU General Public License as 
 * 	published by the Free Software Foundation; either version 2 of 
 *  the License, or (at your option) any later version. 
 *******************************************************************/


define('IN_NEWSLETTER', true); 

require('./pagestart.php'); 

if( $admindata['admin_level'] != ADMIN )
{
	$meta = '<meta http-equiv="Refresh" content="7;url=' . sessid('index.php') . '">'; 
	
	$message  = $lang['Message']['Not_authorized']; 
	$message .= '<br /><br />' . sprintf($lang['Click_return_index'], '<a href="' . sessid('index.php') . '">', '</a>'); 
	trigger_error($message, MESSAGE); 
}

$error = false; 
$msg_error = array(); 

if( isset($_POST['submit']) )
{
	$new_config = array(); 
	foreach( $nl_config AS $name => $value )
	{
		$new_config[$name] = ( isset($_POST[$name]) ) ? trim($_POST[$name]) : $value; 
	}
	
	$new_config['sitename']		= strip_tags($new_config['sitename']); 
	$new_config['urlsite']		= preg_replace('/^http(s)?:\/\/(.*?)\/?$/i', 'http\\1://\\2', $new_config['urlsite']); 
	
	if( $new_config['path'] != '/' )
	{
		$new_config['path'] = preg_replace('/^\/?(.*?)\/?$/i', '/\\1/', $new_config['path']); 
	}
	
	$new_config['date_format']	= ( $new_config['date_format'] == '' ) ? 'd M Y H:i' : $new_config['date_format']; 
	
	if( !($new_config['session_length'] = intval($new_config['session_length'])) )
	{
		$new_config['session_length'] = 3600; 
	}
	
	if( $new_config['upload_path'] != '/' )
	{
		$new_config['upload_path'] = preg_replace('/^\/?(.*?)\/?$/i', '\\1/', $new_config['upload_path']); 
	}
	
	if( !($new_config['max_filesize'] = intval($new_config['max_filesize'])) )
	{
		$new_config['max_filesize'] = 100000; 
	}
	
	$new_config['ftp_server'] 	= preg_replace('/^(?:ftp:\/\/)?(.*)$/i', '\\1', $new_config['ftp_server']); 
	$new_config['emails_sended']= intval($new_config['emails_sended']); 
	
	if( !($new_config['smtp_port'] = intval($new_config['smtp_port'])) )
	{
		$new_config['smtp_port'] = 25; 
	}
	
	if( $new_config['use_ftp'] )
	{
		include($waroot . 'includes/class.attach.php'); 
		
		$resultat = Attach::connect_to_ftp($new_config['ftp_server'], $new_config['ftp_user'], $new_config['ftp_pass'], $new_config['ftp_pasv'], $new_config['ftp_path']); 
		
		if( $resultat['error'] )
		{
			$error = TRUE; 
			$msg_error[] = sprintf(nl2br($lang['Message']['bad_ftp_param']), $resultat['message']); 
		}
		else
		{
			@ftp_quit($resultat['connect_id']); 
		}
	}
	
	if( $new_config['use_smtp'] )
	{
		preg_match('/^http(s)?:\/\/(.*?)\/?$/i', $new_config['urlsite'], $match); 
		
		include($waroot . 'includes/class.mailer.php'); 
		
		$resultat = Smtp::connect_to_smtp($new_config['smtp_host'], $new_config['smtp_port'], $new_config['smtp_user'], $new_config['smtp_pass'], $match[2]); 
		
		if( $resultat['error'] )
		{
			$error = TRUE; 
			$msg_error[] = sprintf(nl2br($lang['Message']['bad_smtp_param']), $resultat['message']); 
		}
		else
		{
			@fclose($resultat['connect_id']); 
		}
	}
	
	if( !$error )
	{
		if( !$db->query_build('UPDATE', CONFIG_TABLE, $new_config) )
		{
			trigger_error('Impossible de mettre  jour la configuration', ERROR); 
		}
		
		$meta = '<meta http-equiv="Refresh" content="4;url=' . sessid('index.php') . '">'; 
		trigger_error('Success_modif', MESSAGE); 
	}
}
else
{
	$new_config = $nl_config; 
}

$hebergeurs = array(1 => $lang['Other'], 2 => 'Online', 3 => 'Nexen'); 

$host_box = '<select name="hebergeur">'; 
for( $i = 1; $i < 4; $i++ )
{
	$selected = ( $new_config['hebergeur'] == $i ) ? ' selected="selected"' : ''; 
	$host_box .= '<option value="' . $i . '"> - ' . $hebergeurs[$i] . ' - </option>'; 
}
$host_box .= '</select>'; 

if( $error )
{
	error_box($msg_error); 
}

include($waroot . 'includes/functions.box.php'); 
include('./page_header.php'); 

$template->set_filenames( array(
	'body' => 'config_body.tpl'
));

$template->assign_vars( array(
	'L_EXPLAIN' => nl2br($lang['Explain']['config']),
	
	'TITLE_CONFIG_LANGUAGE' => $lang['Title']['config_lang'],
	'L_DEFAULT_LANG' => $lang['Default_lang'],
	
	'TITLE_CONFIG_PERSO' => $lang['Title']['config_perso'],
	'L_SITENAME' => $lang['Sitename'],
	'L_URLSITE' => $lang['Urlsite'],
	'L_URLSITE_NOTE' => $lang['Urlsite_note'],
	'L_URLSCRIPT' => $lang['Urlscript'],
	'L_URLSCRIPT_NOTE' => $lang['Urlscript_note'],
	'L_DATE_FORMAT' => $lang['Dateformat'],
	'L_NOTE_DATE' => sprintf($lang['Fct_date'], '<a href="http://www.phpcodeur.net/?page=manuel&amp;chp=function&amp;p=date" target="_blank">', '</a>'), 
	
	'TITLE_CONFIG_COOKIES' => $lang['Title']['config_cookies'],
	'L_EXPLAIN_COOKIES' => nl2br($lang['Explain']['config_cookies']),
	'L_COOKIE_NAME' => $lang['Cookie_name'],
	'L_COOKIE_PATH' => $lang['Cookie_path'],
	'L_LENGTH_SESSION' => $lang['Session_length'],
	'L_SECONDS' => $lang['Seconds'],
	
	'TITLE_CONFIG_JOINED_FILES' => $lang['Title']['config_files'],
	'L_EXPLAIN_JOINED_FILES' => nl2br($lang['Explain']['config_files']),
	'L_UPLOAD_PATH' => $lang['Upload_path'],
	'L_MAX_FILESIZE' => $lang['Max_filesize'],
	'L_MAX_FILESIZE_NOTE' => $lang['Max_filesize_note'],
	'L_OCTETS' => $lang['Octets'],
	'L_USE_FTP' => $lang['Use_ftp'],
	'L_FTP_SERVER' => $lang['Ftp_server'],
	'L_FTP_SERVER_NOTE' => $lang['Ftp_server_note'],
	'L_FTP_PASV' => $lang['Ftp_pasv'],
	'L_FTP_PASV_NOTE' => $lang['Ftp_pasv_note'],
	'L_FTP_PATH' => $lang['Ftp_path'],
	'L_FTP_PATH_NOTE' => $lang['Ftp_path_note'],
	'L_FTP_USER' => $lang['Ftp_user'],
	'L_FTP_PASS' => $lang['Ftp_pass'],
	
	'TITLE_CONFIG_EMAIL' => $lang['Title']['config_email'],
	'L_EXPLAIN_EMAIL' => nl2br($lang['Explain']['config_email']),
	'L_ENGINE_SEND' => $lang['Choice_engine_send'],
	'L_ENGINE_BCC' => $lang['With_engine_bcc'],
	'L_ENGINE_UNIQ' => $lang['With_engine_uniq'],
	'L_EMAILS_SENDED' => $lang['Emails_paquet'],
	'L_EMAILS_SENDED_NOTE' => $lang['Emails_paquet_note'],
	'L_HEBERGEUR' => $lang['Host'],
	'L_USE_SMTP' => $lang['Use_smtp'],
	'L_USE_SMTP_NOTE' => nl2br(sprintf($lang['Use_smtp_note'], '<a href="' . $waroot . 'docs/faq_fr.html">', '</a>')),
	'L_YES' => $lang['Yes'],
	'L_NO' => $lang['No'],
	'L_SMTP_SERVER' => $lang['Smtp_server'],
	'L_SMTP_PORT' => $lang['Smtp_port'],
	'L_SMTP_PORT_NOTE' => $lang['Smtp_port_note'],
	'L_SMTP_USER' => $lang['Smtp_user'],
	'L_SMTP_PASS' => $lang['Smtp_pass'],
	'L_AUTH_SMTP_NOTE' => $lang['Auth_smtp_note'],
	'L_VALID_BUTTON' => $lang['Button']['valid'],
	'L_RESET_BUTTON' => $lang['Button']['reset'],
	
	'TITLE_CONFIG_STATS' => $lang['Title']['config_stats'],
	'L_EXPLAIN_STATS' => nl2br($lang['Explain']['config_stats']),
	'L_DISABLE_STATS' => $lang['Disable_stats'],
	'L_GD_VERSION' => $lang['GD_version'],
	
	'LANG_BOX' => lang_box($new_config['language']),
	'SITENAME' => htmlspecialchars($new_config['sitename']),
	'URLSITE' => $new_config['urlsite'],
	'URLSCRIPT' => $new_config['path'],
	'DATE_FORMAT' => $new_config['date_format'],
	'COOKIE_NAME' => $new_config['cookie_name'],
	'COOKIE_PATH' => $new_config['cookie_path'],
	'LENGTH_SESSION' => $new_config['session_length'],
	'UPLOAD_PATH' => $new_config['upload_path'],
	'MAX_FILESIZE' => $new_config['max_filesize'],
	'CHECKED_USE_FTP_ON' => ( $new_config['use_ftp'] ) ? ' checked="checked"' : '',
	'CHECKED_USE_FTP_OFF' => ( !$new_config['use_ftp'] ) ? ' checked="checked"' : '',
	'CHECKED_FTP_PASV_ON' => ( $new_config['ftp_pasv'] ) ? ' checked="checked"' : '',
	'CHECKED_FTP_PASV_OFF' => ( !$new_config['ftp_pasv'] ) ? ' checked="checked"' : '',
	'FTP_SERVER' => $new_config['ftp_server'],
	'FTP_PATH' => $new_config['ftp_path'],
	'FTP_USER' => $new_config['ftp_user'],
	'FTP_PASS' => $new_config['ftp_pass'],
	'CHECK_ENGINE_BCC' => ( $new_config['engine_send'] == ENGINE_BCC ) ? ' checked="checked"' : '',
	'CHECK_ENGINE_UNIQ' => ( $new_config['engine_send'] == ENGINE_UNIQ ) ? ' checked="checked"' : '',
	'EMAILS_SENDED' => $new_config['emails_sended'],
	'HOST_BOX' => $host_box,
	'CHECKED_USE_SMTP_ON' => ( $new_config['use_smtp'] ) ? ' checked="checked"' : '',
	'CHECKED_USE_SMTP_OFF' => ( !$new_config['use_smtp'] ) ? ' checked="checked"' : '',
	'SMTP_HOST' => $new_config['smtp_host'],
	'SMTP_PORT' => $new_config['smtp_port'],
	'SMTP_USER' => $new_config['smtp_user'],
	'SMTP_PASS' => $new_config['smtp_pass'],
	'CHECKED_DISABLE_STATS_ON' => ( $new_config['disable_stats'] ) ? ' checked="checked"' : '',
	'CHECKED_DISABLE_STATS_OFF' => ( !$new_config['disable_stats'] ) ? ' checked="checked"' : '',
	'SELECTED_GD_PNG' => ( $new_config['gd_img_type'] == 'png' ) ? ' selected="selected"' : '',
	'SELECTED_GD_GIF' => ( $new_config['gd_img_type'] == 'gif' ) ? ' selected="selected"' : '',
	
	'S_HIDDEN_FIELDS' => '<input type="hidden" name="sessid" value="' . $session->session_id . '" />'
)); 

$template->pparse('body'); 

include('./page_footer.php'); 
?>