<?php
/*******************************************************************
 *			
 * 			Fichier			:	class.attach.php 
 * 			Cr le			:	05 avril 2003 
 * 			Dernire modif	:	17 avril 2003 
 * 			Email			:	wascripts@phpcodeur.net 
 * 
 * 				Copyright  2002-2003 phpCodeur
 * 
 *******************************************************************/

/*******************************************************************
 *  This program is free software; you can redistribute it and/or 
 * 	modify it under the terms of the GNU General Public License as 
 * 	published by the Free Software Foundation; either version 2 of 
 *  the License, or (at your option) any later version. 
 *******************************************************************/


if( !defined('CLASS_ATTACH_INC') )
{

define('CLASS_ATTACH_INC', 1); 

class Attach {
	
	var $upload_path 	= ''; 
	
	var $use_ftp 		= false; 
	var $ftp_path 		= ''; 
	var $connect_id		= ''; 
	
	function Attach()
	{
		global $nl_config, $waroot; 
		
		$this->upload_path	= $waroot . preg_replace('/^(.*?)\/?$/', '\\1/', $nl_config['upload_path']); 
		$this->use_ftp		= $nl_config['use_ftp']; 
		
		if( $this->use_ftp )
		{
			$result = $this->connect_to_ftp(
							$nl_config['ftp_server'],
							$nl_config['ftp_user'],
							$nl_config['ftp_pass'],
							$nl_config['ftp_pasv'],
							$nl_config['ftp_path']
						); 
			
			if( $result['error'] )
			{
				trigger_error($result['message'], ERROR); 
			}
			
			$this->connect_id = $result['connect_id']; 
			$this->ftp_path	  = $nl_config['ftp_path']; 
		}
	}
	
	function connect_to_ftp($ftp_server, $ftp_user, $ftp_pass, $ftp_pasv, $ftp_path)
	{
		if( !($connect_id = @ftp_connect($ftp_server)) )
		{
			return array('error' => true, 'message' => 'Ftp_unable_connect'); 
		}
		
		if( $ftp_user != '' && $ftp_pass != '' )
		{
			if( !@ftp_login($connect_id, $ftp_user, $ftp_pass) )
			{
				return array('error' => true, 'message' => 'Ftp_error_login'); 
			}
		}
		
		if( !@ftp_pasv($connect_id, $ftp_pasv) )
		{
			return array('error' => true, 'message' => 'Ftp_error_mode'); 
		}
		
		if( !@ftp_chdir($connect_id, $ftp_path) )
		{
			return array('error' => true, 'message' => 'Ftp_error_path'); 
		}
		
		return array('error' => false, 'connect_id' => $connect_id); 
	}
	
	function joined_file_exists($filename, &$error, &$msg_error)
	{
		global $lang; 
		
		$file_exists = false; 
		$filesize	 = 0; 
		
		if( $this->use_ftp )
		{
			$listing = @ftp_rawlist($this->connect_id, $this->ftp_path); 
			
			if( is_array($listing) && count($listing) )
			{
				foreach( $listing AS $line_info )
				{
					if( preg_match('/^\s*([d-]){1}[rwxst-]{9} .+ ([0-9]*) [a-zA-Z]+ [0-9:\s]+ (.*)$/i', $line_info, $matches) )
					{
						if( $matches[1] != 'd' && $matches[3] == $filename )
						{
							$file_exists = true; 
							$filesize	 = $matche[2]; 
						}
					}
				}
			}
		}
		else if( file_exists(wa_realpath($this->upload_path . $filename)) )
		{
			$file_exists = true; 
			$filesize 	 = @filesize(wa_realpath($this->upload_path . $filename)); 
		}
		
		if( !$file_exists )
		{
			$error = TRUE; 
			$msg_error[] = sprintf($lang['Message']['File_not_exists'], htmlspecialchars($filename)); 
		}
		
		return $filesize; 
	}
	
	function make_filename($prev_physical_name = '')
	{
		global $db; 
		
		$physical_name = md5( uniqid( rand() ) ) . '.dl'; 
		
		if( $physical_name != $prev_physical_name )
		{
			$sql = "SELECT COUNT(file_id) AS test_name 
					FROM " . JOINED_FILES_TABLE . " 
					WHERE file_physical_name = '$physical_name'"; 
			if( !($result = $db->query($sql)) )
			{
				trigger_error('Impossible de tester la table des fichiers joints', ERROR); 
			}
			
			$test_name = $db->result($result, 0, 'test_name'); 
		}
		else
		{
			$test_name = true; 
		}
		
		if( $test_name )
		{
			return $this->make_filename($physical_name); 
		}
		else
		{
			return $physical_name; 
		}
	}
	
	function upload_file($filedata, $log_id, &$error, &$msg_error, $allready_on_server = false)
	{
		global $db, $nl_config, $lang, $waroot; 
		
		if( $allready_on_server )
		{
			if( is_numeric($filedata) )
			{
				$sql = "SELECT file_real_name, file_mimetype 
						FROM " . JOINED_FILES_TABLE . " 
						WHERE file_id = " . $filedata; 
				if( !($result = $db->query($sql)) )
				{
					trigger_error('Impossible de rcuprer les donnes sur ce fichier', ERROR); 
				}
				
				if( !($row = $db->fetch_array($result)) )
				{
					$error = TRUE; 
					$msg_error[] = sprintf($lang['Message']['File_not_exists'], ''); 
				}
				
				$real_filename = $row['file_real_name']; 
				$mime_type	   = $row['file_mimetype']; 
			}
			else
			{
				$real_filename = $physical_filename = $filedata; 
			}
			
			$file_ext = substr($real_filename, (strrpos($real_filename, '.')+1)); 
			
			if( $file_ext == '' )
			{
				$file_ext = 'wa'; 
			}
			
			if( !is_numeric($filedata) )
			{
				if( WA_PHP_VERSION >= 40300 )
				{
					$mime_type = mime_content_type($real_filename); 
				}
				else
				{
					include($waroot . 'includes/class.mailer.php'); 
					$mime_type = Mailer::mime_type($file_ext); 
				}
			}
			
			$filesize = $this->joined_file_exists($real_filename, $error, $msg_error); 
		}
		else
		{
			$real_filename	= $filedata['name']; 
			$filesize		= $filedata['size']; 
			$mime_type		= $filedata['type']; 
			$tmp_filename	= $filedata['tmp_name']; 
			$errno_code		= ( isset($filedata['error']) ) ? intval($filedata['error']) : UPLOAD_ERR_OK; 
			
			$file_ext = substr($real_filename, (strrpos($real_filename, '.')+1)); 
			
			if( $file_ext == '' )
			{
				$file_ext = 'wa'; 
			}
		}
		
		if( !$error && !$allready_on_server && !is_uploaded_file($tmp_filename) )
		{
			$error = TRUE; 
			
			switch( $errno_code )
			{
				case UPLOAD_ERR_INI_SIZE:
					$msg_error[] = $lang['Message']['Upload_error_1']; 
					break;
				
				case UPLOAD_ERR_FORM_SIZE:
					$msg_error[] = $lang['Message']['Upload_error_2']; 
					break;
				
				case UPLOAD_ERR_PARTIAL:
					$msg_error[] = $lang['Message']['Upload_error_3']; 
					break;
				
				case UPLOAD_ERR_NO_FILE:
					$msg_error[] = $lang['Message']['Upload_error_4']; 
					break;
				
				default:
					$msg_error[] = $lang['Message']['Upload_error_5']; 
					break;
			}
		}
		
		if( !$error && preg_match('/[\\:*\/?<">|]+/', $real_filename) )
		{
			$error = TRUE; 
			$msg_error[] = $lang['Message']['Invalid_filename']; 
		}
		
		if( !$error )
		{
			$sql = "SELECT COUNT(fe_id) AS test_extension 
					FROM " . FORBIDDEN_EXT_TABLE . " 
					WHERE fe_ext = '$file_ext'"; 
			if( !($result = $db->query($sql)) )
			{
				trigger_error('Impossible de tester la table des extensions interdites',  ERROR); 
			}
			
			$test_extension = $db->result($result, 0, 'test_extension'); 
			
			if( $test_extension )
			{
				$error = TRUE; 
				$msg_error[] = $lang['Message']['Invalid_ext']; 
			}
		}
		
		if( !$error )
		{
			$sql = "SELECT SUM(file_size) AS total_size 
					FROM " . JOINED_FILES_TABLE . " AS jf, " . LOG_FILES_TABLE . " AS lf 
					WHERE jf.file_id = lf.file_id AND lf.log_id = " . $log_id; 
			if( !($result = $db->query($sql)) )
			{
				trigger_error('Impossible d\'obtenir la somme du poids des fichiers joints', ERROR); 
			}
			
			$total_size = $db->result($result, 0, 'total_size'); 
			
			if( ($total_size + $filesize) > $nl_config['max_filesize'] )
			{
				$error = TRUE; 
				$msg_error[] = sprintf($lang['Message']['weight_too_big'], ($nl_config['max_filesize']-$total_size)); 
			}
		}
		
		if( !$error && !$allready_on_server )
		{
			$physical_filename = $this->make_filename(); 
			
			if( $this->use_ftp )
			{
				$mode = FTP_BINARY; 
				if( preg_match('/text|html/i', $mime_type) )
				{
					$mode = FTP_ASCII; 
				}
								
				$result = @ftp_put($this->connect_id, $physical_filename, $tmp_filename, $mode); 
				
				if( !$result )
				{
					$error = TRUE; 
					$msg_error[] = $lang['Message']['Ftp_error_put']; 
				}
				else
				{
					@ftp_site($this->connect_id, 'CHMOD 0644 ' . $physical_filename); 
				}
			}
			else
			{
				$result = @move_uploaded_file($tmp_filename, $this->upload_path . $physical_filename); 
				
				if( !$result )
				{
					$error = TRUE; 
					$msg_error[] = $lang['Message']['Upload_error_5']; 
				}
				else
				{
					@chmod($this->upload_path . $physical_filename, 0644); 
				}
			}
		}
		
		if( !$error )
		{
			if( is_numeric($filedata) )
			{
				$file_id = $filedata; 
			}
			else
			{
				$sql_data = array(); 
				
				$sql_data['file_real_name']		= $real_filename; 
				$sql_data['file_physical_name']	= $physical_filename; 
				$sql_data['file_size']			= $filesize; 
				$sql_data['file_mimetype']		= $mime_type; 
				
				if( !$db->query_build('INSERT', JOINED_FILES_TABLE, $sql_data) )
				{
					trigger_error('Impossible d\'insrer les donnes du fichier dans la base de donnes', ERROR); 
				}
				
				$file_id = $db->next_id(); 
			}
						
			$sql = "INSERT INTO " . LOG_FILES_TABLE . " (log_id, file_id) 
					VALUES($log_id, $file_id)"; 
			if( !$db->query($sql) )
			{
				trigger_error('Impossible d\'insrer la jointure sur la table log_files', ERROR); 
			}
		}
		
		$this->quit(); 
	}
	
	function download_file($file_id)
	{
		global $db, $admindata, $lang; 
		
		$sql = "SELECT f.file_real_name, f.file_physical_name, f.file_size, f.file_mimetype 
				FROM " . JOINED_FILES_TABLE . " AS f, " . LOG_FILES_TABLE . " AS lf, " . LOG_TABLE . " AS l 
				WHERE f.file_id = $file_id AND lf.file_id = f.file_id AND lf.log_id = l.log_id 
				  AND l.liste_id = " . $admindata['session_liste']; 
		if( !($result = $db->query($sql)) )
		{
			trigger_error('Impossible d\'obtenir les donnes sur ce fichier', ERROR); 
		}
		
		if( $row = $db->fetch_array($result) )
		{
			if( $this->use_ftp )
			{
				$mode = FTP_BINARY; 
				if( preg_match('/text|html/i', $row['file_mimetype']) )
				{
					$mode = FTP_ASCII; 
				}
				
				$tmp_path = ( @ini_get('open_basedir') ) ? $this->upload_path . 'tmp' : '/tmp'; 
				
				$tmp_filename = tempnam($tmp_path, 'wa0'); 
				
				if( !@ftp_get($this->connect_id, $tmp_filename, $row['file_physical_name'], $mode) )
				{
					trigger_error('Ftp_error_get', ERROR); 
				}
				
				$filedata = implode('', file($tmp_filename)); 
			}
			else
			{
				$filedata = implode('', file(wa_realpath($this->upload_path . $row['file_physical_name']))); 
			}
			
			$this->quit(); 
			$this->send_file($row['file_real_name'], $row['file_mimetype'], $filedata, $row['file_size']); 
		}
		
		trigger_error(sprintf($lang['Message']['File_not_exists'], ''), MESSAGE); 
	}
	
	function delete_joined_files($massive_delete, $log_id_ary, $file_id_ary = array())
	{
		global $db; 
		
		if( !is_array($log_id_ary) )
		{
			$tmp_ary = array(); 
			
			if( is_numeric($log_id_ary) )
			{
				$tmp_ary[] = $log_id_ary; 
			}
			
			$log_id_ary = $tmp_ary; 
		}
		
		if( !is_array($file_id_ary) )
		{
			$tmp_ary = array(); 
			
			if( is_numeric($file_id_ary) )
			{
				$tmp_ary[] = $file_id_ary; 
			}
			
			$file_id_ary = $tmp_ary; 
		}
		
		if( count($log_id_ary) )
		{
			$filename_ary = array(); 
			$is_deleted = false; 
			
			switch( DATABASE )
			{
				case 'mysql':
				case 'mysql4':
					if( $massive_delete )
					{
						$sql = "SELECT file_id 
								FROM " . LOG_FILES_TABLE . " 
								WHERE log_id IN(" . implode(', ', $log_id_ary) . ") 
								GROUP BY file_id"; 
						if( !($result = $db->query($sql)) )
						{
							trigger_error('Impossible d\'obtenir la liste des abonns', ERROR); 
						}
						
						$id_ary = array(); 
						while( $row = $db->fetch_array($result) )
						{
							$id_ary[] = $row['file_id']; 
						}
					}
					else
					{
						$id_ary = $file_id_ary; 
					}
					
					if( count($id_ary) )
					{
						$sql = "SELECT lf.file_id, jf.file_physical_name 
								FROM " . LOG_FILES_TABLE . " AS lf, " . JOINED_FILES_TABLE . " AS jf 
								WHERE lf.file_id IN(" . implode(', ', $id_ary) . ") 
								  AND lf.file_id = jf.file_id 
								GROUP BY lf.file_id 
								HAVING COUNT(lf.file_id) = 1"; 
						if( $result = $db->query($sql) )
						{
							$id_ary = array(); 
							while( $row = $db->fetch_array($result) )
							{
								$id_ary[]  		= $row['file_id']; 
								$filename_ary[] = $row['file_physical_name']; 
							}
							
							if( count($id_ary) )
							{
								$sql = "DELETE FROM " . JOINED_FILES_TABLE . " 
									WHERE file_id IN(" . implode(', ', $id_ary) . ")"; 
								if( !$db->query($sql) )
								{
									trigger_error('Impossible de supprimer les entres inutiles de la table des fichiers joints', ERROR); 
								}
							}
							
							$is_deleted = true; 
						}
					}
					break;
				
				default:
					if( $massive_delete )
					{
						$sql_where = "SELECT file_id FROM " . LOG_FILES_TABLE . " 
								WHERE log_id IN(" . implode(', ', $log_id_ary) . ") GROUP BY file_id"; 
					}
					else
					{
						$sql_where = implode(', ', $file_id_ary); 
					}
					
					$sql = "SELECT lf.file_id, jf.file_physical_name 
							FROM " . LOG_FILES_TABLE . " AS lf, " . JOINED_FILES_TABLE . " AS jf 
							WHERE lf.file_id IN($sql_where) AND lf.file_id = jf.file_id 
							GROUP BY lf.file_id 
							HAVING COUNT(lf.file_id) = 1"; 
					if( !($result = $db->query($sql)) )
					{
						trigger_error('Impossible d\'obtenir la liste des fichiers joints  supprimer', ERROR); 
					}
					
					$id_ary = array(); 
					while( $row = $db->fetch_array($result) )
					{
						$id_ary[]		= $row['file_id']; 
						$filename_ary[] = $row['file_physical_name']; 						
					}
					
					if( count($id_ary) )
					{
						$sql = "DELETE FROM " . JOINED_FILES_TABLE . " 
							WHERE file_id IN(" . implode(', ', $id_ary) . ")"; 
						if( !$db->query($sql) )
						{
							trigger_error('Impossible de supprimer les entres inutiles de la table des fichiers joints', ERROR); 
						}
					}
					
					$is_deleted = true; 
					break;
			}
			
			if( $is_deleted )
			{
				$sql = "DELETE FROM " . LOG_FILES_TABLE . " 
					WHERE log_id IN(" . implode(', ', $log_id_ary) . ") 
					  AND file_id IN(" . implode(', ', $file_id_ary) . ")"; 
				if( !$db->query($sql) )
				{
					trigger_error('Impossible de supprimer les entres de la table log_files', ERROR); 
				}
				
				foreach( $filename_ary AS $filename )
				{
					if( $this->use_ftp )
					{
						if( !@ftp_delete($this->connect_id, $filename) )
						{
							trigger_error('Ftp_error_del', ERROR); 
						}
					}
					else
					{
						$this->remove_file(wa_realpath($this->upload_path . $filename)); 
					}
				}
				
				return count($filename_ary); 
			}			
		}
		
		return false; 
	}
	
	function remove_file($filename)
	{
		@chmod($filename, 0775); 
		@unlink($filename); 
		
		if( @file_exists($filename) )
		{
			@system('del ' . str_replace('/', '\\', $filename)); 
		}
	}
	
	function send_file($filename, $mime_type, $filedata, $filesize = 0)
	{
		global $_SERVER; 
		
		$browser = ( !empty($_SERVER['HTTP_USER_AGENT']) ) ? $_SERVER['HTTP_USER_AGENT'] : ''; 
		
		if( stristr($browser, 'Opera') )
		{
			$browser = 'opera'; 
		}
		else if( stristr($browser, 'MSIE') )
		{
			$browser = 'ie'; 
		}
		else if( stristr($browser, 'Mozilla') )
		{
			$browser = 'mozilla'; 
		}
		else
		{
			$browser = 'ie'; 
		}
		
		if( $mime_type == '' || $mime_type == 'application/octetstream' || $mime_type == 'application/octet-stream' )
		{
			if( $browser == 'ie' || $browser == 'opera' )
			{
				$mime_type = 'application/octetstream'; 
			}
			else
			{
				$mime_type = 'application/octet-stream'; 
			}
		}
		
		header('Expires: 0'); 
		header('Content-Transfer-Encoding: none'); 
		header('Content-Type: ' . $mime_type); 
		
		if( $browser == 'ie' || $browser == 'opera' )
		{
			header('Content-Disposition: attachment; filename="' . $filename . '"'); 
			header('Content-Description: File Transfert'); 
			header('Cache-Control: must-revalidate, post-check=0, pre-check=0'); 
        	header('Pragma: public'); 
		}
		else
		{
			header('Content-Disposition: attachment; filename=' . $filename); 
			header('Pragma: no-cache'); 
		}
		
		if( $filesize )
		{
			header('Content-length: ' . $filesize); 
		}
		
		echo $filedata; 
		
		exit;
	}
	
	function quit()
	{
		if( $this->use_ftp )
		{
			$quit = ( WA_PHP_VERSION >= 40200 ) ? 'ftp_close' : 'ftp_quit'; 
			
			@$quit($this->connect_id); 
		}
	}
}

}
?>