<?php
/*******************************************************************
 *			
 * 			Fichier			:	functions.php 
 * 			Cr le			:	03 mars 2003 
 * 			Dernire modif	:	16 avril 2003 
 * 			Email			:	wascripts@phpcodeur.net 
 * 
 * 				Copyright  2002-2003 phpCodeur
 * 
 *******************************************************************/

/*******************************************************************
 *  This program is free software; you can redistribute it and/or 
 * 	modify it under the terms of the GNU General Public License as 
 * 	published by the Free Software Foundation; either version 2 of 
 *  the License, or (at your option) any later version. 
 *******************************************************************/


if( !defined('FUNCTIONS_BOX_INC') )
{

define('FUNCTIONS_BOX_INC', true); 

//
// Liste droulante des diffrentes langues disponibles 
//
function lang_box($default_lang = '')
{
	global $waroot; 
	
	$lang_ary = array(); 
	
	$res = @opendir($waroot . 'language/'); 	
	while( $filename = @readdir($res) ) 
	{
		if( preg_match('/^lang_([a-z0-9-]+)\.php$/', $filename, $match) )
		{
			$lang_ary[] = $match[1]; 
		}
	}
	@closedir($res); 
	
	if( count($lang_ary) > 1 )
	{
		$lang_box = "<select name=\"language\">\n"; 
		
		asort($lang_ary); 
		foreach( $lang_ary AS $lang_name )
		{
			$selected = ( $default_lang == $lang_name ) ? ' selected="selected"' : ''; 
			$lang_box .= '<option value="' . $lang_name . '"' . $selected . '> - ' . $lang_name . " - </option>\n"; 
		}
		
		$lang_box .= "</select>\n"; 
	}
	else
	{
		list($lang_name) = $lang_ary; 
		
		$lang_box = $lang_name . '<input type="hidden" name="language" value="' . $lang_name . '" />'; 
	}
	
	return $lang_box; 
}

function format_box($select_name, $default_format = 0, $option_submit = false, $multi_format = false)
{
	$format_box = '<select name="' . $select_name . '"'; 
	
	if( $option_submit )
	{
		$format_box .= ' onchange="document.forms[\'logs\'].submit();">'; 
	}
	else
	{
		$format_box .= '>'; 
	}
	
	$format_box .= ( $default_format == FORMAT_TEXTE ) ? '<option value="1" selected="selected"> - texte - </option>' : '<option value="1"> - texte - </option>'; 
	$format_box .= ( $default_format == FORMAT_HTML ) ? '<option value="2" selected="selected"> - html - </option>' : '<option value="2"> - html - </option>';
	
	if( $multi_format )
	{
		$format_box .= ( $default_format == FORMAT_MULTIPLE ) ? '<option value="3" selected="selected"> - texte &amp; html - </option>' : '<option value="3"> - texte &amp; html - </option>';
	}
	
	$format_box .= '</select>'; 
	
	return $format_box; 
}

function date_box($month, $year)
{
	global $db, $datetime, $admindata; 
	
	$sql = "SELECT MIN(a.abo_register_date) AS first_abo 
		FROM " . ABONNES_TABLE . " AS a, " . ABO_LISTE_TABLE . " AS al 
		WHERE al.liste_id = " . $admindata['session_liste'] . " AND a.abo_id = al.abo_id 
		  AND a.abo_status = " . ABO_ACTIF; 
	if( !($result = $db->query($sql)) )
	{
		trigger_error('Impossible d\'obtenir la date du premier abonn', ERROR); 
	}
	
	if( !($first_abo = $db->result($result, 0, 'first_abo')) )
	{
		$first_abo = time(); 
	}
		
	$m = date('m'); 
	$y = date('Y'); 
	
	$first_m = date('m', $first_abo); 
	$first_y = date('Y', $first_abo); 
	
	$date_box = '<select name="date" onchange="this.form.submit();">'; 
	
	do
	{
		$toc = ( $m == $first_m && $y == $first_y ) ? false : true; 
		
		$str_month = date('F', mktime(0, 0, 0, $m, 1, $y)); 
		
		$selected = ( $month == $m && $year == $y ) ? ' selected="selected"' : ''; 
		$date_box .= '<option value="' . $m . '_' . $y . '"' . $selected . '> - ' . $datetime[$str_month] . ' ' . $y . ' - </option>'; 
		
		$m--; 
		if( $m == 0 )
		{
			$m = 12; 
			$y--; 
		}
	}
	while( $toc ); 
	
	$date_box .= '</select>'; 
	
	return $date_box; 
}

}
?>