<?php
/*******************************************************************
 *			
 * 			Fichier			:	functions.php 
 * 			Cr le			:	27 mars 2002 
 * 			Dernire modif	:	17 avril 2003 
 * 			Email			:	wascripts@phpcodeur.net 
 * 
 * 				Copyright  2002-2003 phpCodeur
 * 
 *******************************************************************/

/*******************************************************************
 *  This program is free software; you can redistribute it and/or 
 * 	modify it under the terms of the GNU General Public License as 
 * 	published by the Free Software Foundation; either version 2 of 
 *  the License, or (at your option) any later version. 
 *******************************************************************/


if( !defined('FUNCTIONS_INC') )
{

define('FUNCTIONS_INC', true); 

//
// Gnrateur de cl alatoire 
//
function generate_key($num_char = 32)
{
	$rand_str = md5( uniqid( rand() ) ); 
	
	return ( $num_char >= 32 ) ? $rand_str : substr($rand_str, 0, $num_char); 
}

function make_script_url($url = '')
{
	global $nl_config; 
	
	$script_url  = preg_replace('/^http(s)?:\/\/(.*?)\/?$/', 'http\\1://\\2', $nl_config['urlsite']); 
	$script_url .= ( getenv('SERVER_PORT') != 80 ) ? ':' . getenv('SERVER_PORT') : ''; 
	$script_url .= ( $nl_config['path'] != '/' ) ? preg_replace('/^\/?(.*?)\/?$/', '/\\1/', $nl_config['path']) : '/'; 
	$script_url .= $url; 
	
	return $script_url; 
}

function get_data($liste_id_mixed)
{
	global $db; 
	
	if( is_array($liste_id_mixed) )
	{
		$sql_where = 'IN (' . implode(', ', $liste_id_mixed) . ')'; 
	}
	else
	{
		$sql_where = '= ' . $liste_id_mixed; 
	}
	
	$data = array('num_inscrits' => 0, 'num_temp' => 0, 'num_logs' => 0, 'last_log' => 0); 
	
	$sql = "SELECT COUNT(DISTINCT(a.abo_id)) AS num_abo, a.abo_status 
			FROM " . ABONNES_TABLE . " AS a, " . ABO_LISTE_TABLE . " AS al 
			WHERE al.liste_id $sql_where AND a.abo_id = al.abo_id 
			GROUP BY a.abo_status"; 
	if( !($result = $db->query($sql)) )
	{
		trigger_error('Impossible d\'obtenir le nombre d\'inscrits/inscrits en attente', ERROR); 
	}
	
	while( $row = $db->fetch_array($result) )
	{
		if( $row['abo_status'] == ABO_ACTIF )
		{
			$data['num_inscrits'] = $row['num_abo']; 
		}
		else
		{
			$data['num_temp'] = $row['num_abo']; 
		}
	}
	
	$sql = "SELECT COUNT(log_id) AS num_logs, MAX(log_date) AS last_log 
			FROM " . LOG_TABLE . " 
			WHERE liste_id $sql_where AND log_status = " . STATUS_SENDED; 
	if( !($result = $db->query($sql)) )
	{
		trigger_error('Impossible d\'obtenir le nombre de logs envoys', ERROR); 
	}
	
	if( $row = $db->fetch_array($result) )
	{
		$data['num_logs'] = $row['num_logs']; 
		$data['last_log'] = $row['last_log']; 
	}
	
	return $data; 
}

//
// Fonction de redirection du script 
// - URL absolue, d'aprs les specifications HTTP/1.1 
//
function Location($url)
{
	global $nl_config; 
	
	$use_refresh = @preg_match("#Microsoft|WebSTAR|Xitami#i", getenv('SERVER_SOFTWARE')); 
	$header_location = ( $use_refresh ) ? 'Refresh: 0; URL=' : 'Location: '; 
	
	$absolute_url  = make_script_url(); 
	$absolute_url .= ( defined('IN_ADMIN') ) ? 'admin/' : ''; 
	$absolute_url .= str_replace('&amp;', '&', $url); 
	
	header($header_location . $absolute_url); 
	
	//
	// If redirect header not work 
	//
	echo '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">'; 
	echo '<html><head><meta http-equiv="Refresh" content="0;url=' . $absolute_url . '"></head><body>'; 
	echo '<br />Your browser do not support meta redirect, click <a href="' . $absolute_url . '">here</a> to go on next page. <br />'; 
	echo '</body></html>'; 
	
	exit;
}

//
// Initialisation des prfrences 
//
function load_settings($admindata = array())
{
	global $waroot, $nl_config, $db, $lang, $datetime; 
	
	if( !is_array($admindata) )
	{
		$admindata = array(); 
	}
	
	if( !empty($admindata['admin_lang']) )
	{
		$nl_config['language'] = $admindata['admin_lang']; 
	}
	
	if( !empty($admindata['admin_dateformat']) )
	{
		$nl_config['date_format'] = $admindata['admin_dateformat']; 
	}
	
	$language_path = wa_realpath($waroot . 'language/lang_' . $nl_config['language'] . '.php'); 
	
	if( !@file_exists($language_path) )
	{
		$nl_config['language'] = 'francais'; 
		$language_path = wa_realpath($waroot . 'language/lang_' . $nl_config['language'] . '.php'); 
		
		if( !@file_exists($language_path) )
		{
			trigger_error('<b>Les fichiers de language sont introuvables !</b>', CRITICAL_ERROR); 
		}
	}
	
	include($language_path); 
}


//
// Gestionnaire d'erreur personnalis du script 
//
function wanewsletter_handler($errno, $errstr, $errfile, $errline)
{
	global $waroot, $db, $nl_config, $admindata, $auth, $template, $meta, $lang, $nav_links, $simple_header, $message; 
	
	$debug_text = ''; 
	
	if( ( $errno == CRITICAL_ERROR || $errno == ERROR ) && ( defined('IN_ADMIN') || DEBUG_MODE ) )
	{
		if( !empty($db->sql_error['message']) )
		{
			$debug_text .= '<u>SQL errno</u> : ' . $db->sql_error['errno'] . "<br />\n"; 
			$debug_text .= '<u>SQL error</u> : ' . $db->sql_error['message'] . "<br />\n<br />\n"; 
		}
		
		$debug_text .= '<u>Fichier</u> : ' . basename($errfile) . " \n<u>Ligne</u> : " . $errline . ' <br />'; 
	}
	
	if( !empty($lang['Message'][$errstr]) )
	{
		$errstr = $lang['Message'][$errstr]; 
	}
	
	if( $debug_text != '' )
	{
		$errstr .= "<br /><br />\n\n" . $debug_text; 
	}
	
	switch( $errno )
	{
		case CRITICAL_ERROR:
			echo "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n"; 
			echo "<html>\n<head>\n<title>Erreur critique !</title>\n</head>\n<body>\n\n"; 
			echo "<h2>Erreur critique !</h2>\n\n" . $errstr . "\n\n"; 
			echo "</body>\n</html>\n"; 
			
			exit;
			break; 
		case ERROR:			
		case MESSAGE:
			if( !defined('IN_WA_FORM') )
			{
				if( $errno == ERROR )
				{
					$msg_title = '<span style="color: #FF3333">' . $lang['Title']['error'] . '</span>'; 
				}
				else if( $errno == MESSAGE )
				{
					$msg_title = '<span style="color: #33BB33">' . $lang['Title']['info'] . '</span>'; 
				}
				
				if( !defined('HEADER_INC') )
				{
					include('./page_header.php');
				}
				
				$template->set_filenames(array(
					'body' => 'message_body.tpl'
				));
				
				$template->assign_vars( array(
					'MSG_TITLE' => $msg_title,
					'MSG_TEXT' => $errstr
				));
				
				$template->pparse('body');
				
				include('./page_footer.php'); 
			}
			
			$message = $errstr; 
			break;
	}
	
	if( !defined('STATS_PATH') && $errno != ERROR && DEBUG_MODE > 1 )
	{
		if( $errno == E_WARNING )
		{
			echo '<b>Warning !</b> : '; 
		}
		else if( $errno == E_NOTICE )
		{
			echo '<b>Notice</b> : '; 
		}
		else
		{
			exit;
		}
		
		echo $errstr . ' in <b>' . basename($errfile) . '</b> on line <b>' . $errline . '</b></b><br />'; 
	}
}

//
// Fonction d'affichage par page.
//
// $url -> adresse vers laquelle doivent pointer les liens de navigation
// $total_num -> nombre total d'lments  afficher
// $num_per_page -> nombre d'lments par page
// $page_id -> identifiant de la page en cours
//
function navigation($url, $total_num, $num_per_page, $page_id)
{
	global $lang;
	
	$total_pages = ceil($total_num / $num_per_page);
	
	// premier caractre de l'url au moins en position 1 
	// on place un espace  la position 0 de la chane
	$url = ' ' . $url; 
	
	$url = ( strpos($url, '?') ) ? $url . '&amp;' : $url . '?'; 
	
	// suppression de l'espace prcdemment ajout 
	$url = substr($url, 1); 
	
	if( $total_pages == 1 )
	{
		return '&nbsp;';
	}
	
	$nav_string = ''; 
		
	if( $total_pages > 10 )
	{
		if( $page_id > 10 )
		{
			$prev = $page_id - 1; 
			while( substr($prev, -1, 1) != 0 )
			{
				$prev -= 1; 
			}
			
			$nav_string .= '<a href="' . $url . 'page=' . $prev . '">' . $lang['Prev'] . '</a> &nbsp;&nbsp;';
		}
		
		$current = $page_id;
		while( substr($current, -1, 1) != 1 )
		{
			$current -= 1; 
		}
		
		for( $i = $current; $i < $current + 10; $i++ )
		{
			if( $i < $total_pages + 1 )
			{
				$nav_string .= ( $i == $page_id ) ? '<b>' . $i . '</b>' : '<a href="' . $url . 'page=' . $i . '">' . $i . '</a>';
				if ( $i <  $current + 9 && $i < $total_pages )
				{
					$nav_string .= ', ';
				}
			}
		}
		
		$page_max = $page_id; 
		while( substr($page_max, -1, 1) != 0 )
		{
			$page_max += 1; 
		}			
		$next = $page_max + 1; 
		
		if( $total_pages >= $next )
		{
			$nav_string .= '&nbsp;&nbsp; <a href="' . $url . 'page=' . $next . '">' . $lang['Next'] . '</a>';
		}
	}
	else
	{
		for( $i = 1; $i < $total_pages + 1; $i++ )
		{
			$nav_string .= ( $i == $page_id ) ? '<b>' . $i . '</b>' : '<a href="' . $url . 'page=' . $i . '">' . $i . '</a>';

			if ( $i <  $total_pages )
			{
				$nav_string .= ', ';
			}
		}
	}
	
	return $nav_string; 
}

//
// Fonction de renvoi de date selon la langue
//
// @param : 
// $dateformat 	=> Format de la date 
// $timestamp 	=> timestamp unix  convertir
// 
// En sortie, une date formate 
//
function convert_time($dateformat, $timestamp)
{
	static $orig_ary, $repl_ary; 
	
	if( !isset($orig_ary) || !isset($repl_ary) )
	{
		global $datetime; 
		
		$orig_ary = $repl_ary = array(); 
		
		foreach( $datetime AS $orig_word => $repl_word )
		{
			$orig_ary[] = '/\b' . $orig_word . '\b/i'; 
			$repl_ary[] = $repl_word; 
		}
	}
	
	return preg_replace($orig_ary, $repl_ary, date($dateformat, $timestamp)); 
}

//
// Liste droulante pour grer les diffrentes listes 
//
function build_listbox($mode, $auth_type, $jump_to = '')
{
	global $db, $admindata, $auth, $template, $lang; 
	
	$list_box = false; 
	$tmp_box  = ''; 
	$args_ary = func_get_args(); 
	
	if( $mode == 'display' )
	{
		$jump_to = $args_ary[2]; 
		$select_name = 'liste'; 
	}
	else
	{
		$select_name  = ( !empty($args_ary[2]) ) ? $args_ary[2] : 'liste'; 
		$not_this_id  = ( !empty($args_ary[3]) ) ? $args_ary[3] : 0; 
		$confirm_only = ( !empty($args_ary[4]) ) ? $args_ary[4] : 0; 
	}
	
	$liste_id_ary = $auth->check_auth($auth_type); 
		
	foreach( $auth->listdata AS $liste_id => $data )
	{
		if( in_array($liste_id, $liste_id_ary) && ( $mode == 'display' || ( $liste_id != $not_this_id && ( !$confirm_only || $data['confirm_subscribe'] ) ) ) )
		{
			$selected = ( $admindata['session_liste'] == $liste_id ) ? ' selected="selected"' : ''; 
			
			$liste_name = $data['liste_name']; 
			if( strlen($liste_name) > 30 )
			{
				$liste_name = substr($liste_name, 0, 30); 
				$liste_name = substr($liste_name, 0, strrpos($liste_name, ' ')) . '...'; 
			}
			
			$tmp_box .= '<option value="' . $liste_id . '"' . $selected . '> - ' . $liste_name . ' - </option>'; 
		}			
	}
	
	if( $tmp_box != '' )
	{
		$list_box  = '<select name="' . $select_name . '"'; 
		if( $mode == 'display' )
		{
			$list_box .= ' onchange="if( this.options[this.selectedIndex].value != 0 ) { this.form.submit(); }">'; 
			$list_box .= '<option value="0"> - ' . $lang['Choice_liste'] . ' - </option>'; 
			$list_box .= '<option value="0"> -------------------- </option>'; 
		}
		else
		{
			$list_box .= '>'; 
		}
		
		$list_box .= $tmp_box . '</select>'; 
		
		if( $mode == 'display' )
		{
			$template->set_filenames(array(
				'listbox' => 'listbox.tpl'
			)); 
			
			$template->assign_vars(array(
				'L_VIEW_LIST' => $lang['View_liste'],
				'L_BUTTON_GO' => $lang['Button']['go'],
				
				'S_LISTBOX' => $list_box,
				'S_HIDDEN_FIELDS' => '<input type="hidden" name="sessid" value="' . $admindata['session_id'] . '" />',
				
				'U_LISTBOX' => sessid($jump_to)
			)); 
			
			$template->assign_var_from_handle('LISTBOX', 'listbox'); 
		}		
	}
	
	return $list_box; 
}


function error_box($msg_error_mixed)
{
	global $template; 
	
	$msg_error = '<ul type="square">'; 
	if( is_array($msg_error_mixed) )
	{
		foreach( $msg_error_mixed AS $msg )
		{
			$msg_error .= '<li> ' . $msg . ' </li>'; 
		}
	}
	else
	{
		$msg_error .= '<li> ' . $msg_error_mixed . ' </li>'; 
	}
	$msg_error .= '</ul>'; 
	
	$template->set_filenames( array(
		'error_body' => 'error_box_body.tpl'
	));
	
	$template->assign_vars( array(
		'MSG_ERROR' => $msg_error
	));
	
	$template->assign_var_from_handle('ERROR_BOX', 'error_body'); 
}

//
// Purge de la table des abonns 
//
function purge_liste($liste_id = 0, $limitevalidate = 0, $purge_freq = 0)
{
	global $db, $nl_config; 
	
	if( !$liste_id )
	{
		$total_entries_deleted = 0; 
		
		$sql = "SELECT liste_id, limitevalidate, purge_freq 
				FROM " . LISTE_TABLE . " 
				WHERE purge_next < " . time() . " AND auto_purge = " . TRUE; 
		if( !($result = $db->query($sql)) )
		{
			trigger_error('Impossible d\'obtenir les listes de diffusion  purger', ERROR); 
		}
		
		while( $row = $db->fetch_array($result) )
		{
			$total_entries_deleted += purge_liste($row['liste_id'], $row['limitevalidate'], $row['purge_freq']); 
		}
		
		if( ereg('^mysql', DATABASE) )
		{
			$db->query("OPTIMIZE TABLE `" . ABONNES_TABLE . "`, `" . ABO_LISTE_TABLE . "`"); 
		}
		
		return $total_entries_deleted; 
	}
	else
	{
		$sql = "SELECT a.abo_id 
				FROM " . ABONNES_TABLE . " AS a, " . ABO_LISTE_TABLE . " AS al 
				WHERE al.liste_id = $liste_id AND a.abo_id = al.abo_id AND a.abo_status = " . ABO_INACTIF . " 
				  AND a.abo_register_date < " . (time() - ($limitevalidate * 86400)); 
		if( !($result = $db->query($sql)) )
		{
			trigger_error('Impossible d\'obtenir les entres  supprimer', ERROR); 
		}
		
		$abo_id_ary = array(); 
		while( $row = $db->fetch_array($result) )
		{
			$abo_id_ary[] = $row['abo_id']; 
		}
		
		if( $num_abo_deleted = count($abo_id_ary) )
		{
			$db->transaction(START_TRC); 
			
			$sql = "DELETE FROM " . ABO_LISTE_TABLE . " 
				WHERE abo_id IN(" . implode(', ', $abo_id_ary) . ")"; 
			if( !$db->query($sql) )
			{
				trigger_error('Impossible de supprimer les entres primes de la table abo_liste', ERROR); 
			}
			
			$sql = "DELETE FROM " . ABONNES_TABLE . " 
				WHERE abo_id IN(" . implode(', ', $abo_id_ary) . ")"; 
			if( !$db->query($sql) )
			{
				trigger_error('Impossible de supprimer les entres primes de la table abonnes', ERROR); 
			}
			
			$sql = "UPDATE " . LISTE_TABLE . " 
					SET purge_next = " . (time() + ($purge_freq * 86400)) . " 
					WHERE liste_id = " . $liste_id; 
			if( !$db->query($sql) )
			{
				trigger_error('Impossible de mettre  jour la table liste', ERROR); 
			}
			
			$db->transaction(END_TRC); 
		}
				
		return $num_abo_deleted; 
	}
}

// 
// Simulation de la configuration magic_quotes_gpc  on 
//
function emul_magic_quotes_gpc(&$data)
{
	if( is_array($data) )
	{
		foreach( $data AS $key => $val )
		{
			if( is_array($val) )
			{
				emul_magic_quotes_gpc($val); 
			}
			else
			{
				$data[$key] = addslashes($val); 
			}
		}
	}
}

function wa_realpath($relative_path)
{
	global $waroot, $_SERVER; 
	
	if( @function_exists('realpath') && @realpath($waroot . 'includes/functions.php') )
	{
		return str_replace('\\', '/', realpath($relative_path)); 
	}
	else
	{
		$script_path = ( !empty($_SERVER['SCRIPT_FILENAME']) ) ? dirname($_SERVER['SCRIPT_FILENAME']) : ''; 
		
		if( $script_path != '' )
		{
			$script_path = str_replace('\\', '/', $script_path); 
			
			$ary = explode('/', $relative_path); 
			$z = array(); 
			
			for( $i = 0; $i < count($ary); $i++ )
			{
				if( $ary[$i] != '..' && $ary[$i] != '.' )
				{
					$z[] = $ary[$i]; 
				}
				else if( $ary[$i] == '..' )
				{
					$script_path = substr($script_path, 0, strrpos($script_path, '/')); 
				}
			}
			
			return $script_path . '/' . implode('/', $z); 
		}
	}
	
	return $relative_path; 
}

//
// Fonction inverse de la fonction htmlspecialchars() 
//
function unhtmlspecialchars($input)
{
	$html_entities = array('/&lt;/', '/&gt;/', '/&quot;/', '/&amp;/'); 
	$html_replace  = array('<', '>', '"', '&'); 
	
	return preg_replace($html_entities, $html_replace, $input); 
}

//
// Fonction ayant le mme but que array_map()
// Cette fonction n'tant disponible qu' partir de php 4.0.6, 
// le script dispose d'une alternative au cas o 
//
function wa_array_map($callback)
{
	$args_ary = func_get_args(); 
	
	if( @function_exists($callback) )
	{
		$code = "\$result_ary = array();\n"; 
		
		$total_item = count($args_ary[1]); 
		for( $i = 0; $i < $total_item; $i++ )
		{
			$code .= "\$result_ary[$i] = $callback("; 
			
			for( $j = 1; $j < count($args_ary); $j++ )
			{
				$code .= ( $j == 1 ) ? '' : ', '; 
				$code .= "\$args_ary[$j][$i]"; 
			}
			
			$code .= ");\n"; 
		}
		
		eval($code); 		
	}
	
	return ( isset($result_ary) && is_array($result_ary) ) ? $result_ary : false; 
}


//
// Parsing d'un fichier sql 
//
function make_sql_ary($input, $glue, $prefixe = '')
{
	$comments = false;
	$output   = array();
	$lines    = explode("\n", $input); 
	$tmp 	  = ''; 
	
	$total_lines = count($lines); 	
	for( $i = 0; $i < $total_lines; $i++ )
	{
		if( preg_match('/^\/\*/', trim($lines[$i])) )
		{
			$comments = true;
		}
		
		if( !$comments )
		{
			if( strlen(trim($lines[$i])) > 0 && $lines[$i]{0} != '#' )
			{
				$tmp .= $lines[$i] . "\n"; 
				
				if( ereg($glue . "[\r\n\t\s]*$", $lines[$i]) )
				{
					$output[] = trim($tmp); 
					$tmp = ''; 
				}
			}
		}
		else
		{
			$lines[$i] = ''; 
		}
		
		if( preg_match('/\*\/$/', trim($lines[$i])) )
		{
			$comments = false;
		}
	}
	
	if( $prefixe != '' )
	{
		$output = preg_replace('/wa_/', $prefixe, $output); 
	}
	
	return $output; 
}

}
?>