<?php
/*******************************************************************
 *			
 * 			Fichier			:	install.php 
 * 			Cr le			:	30 juillet 2002 
 * 			Dernire modif	:	17 avril 2003 
 * 			Email			:	wascripts@phpcodeur.net 
 * 
 * 				Copyright  2002-2003 phpCodeur
 * 
 *******************************************************************/

/*******************************************************************
 *  This program is free software; you can redistribute it and/or 
 * 	modify it under the terms of the GNU General Public License as 
 * 	published by the Free Software Foundation; either version 2 of 
 *  the License, or (at your option) any later version. 
 *******************************************************************/


define('IN_INSTALL', true); 

$default_lang = 'francais'; 
$new_version = '2.2-Alpha'; 
$waroot = '../'; 

$sql_drop = array(); 
$sql_drop[]	= "DROP TABLE wa_abo_liste"; 
$sql_drop[]	= "DROP TABLE wa_abonnes"; 
$sql_drop[]	= "DROP TABLE wa_admin"; 
$sql_drop[]	= "DROP TABLE wa_auth_admin"; 
$sql_drop[]	= "DROP TABLE wa_ban_list"; 
$sql_drop[]	= "DROP TABLE wa_config"; 
$sql_drop[]	= "DROP TABLE wa_joined_files"; 
$sql_drop[]	= "DROP TABLE wa_forbidden_ext"; 
$sql_drop[]	= "DROP TABLE wa_liste"; 
$sql_drop[]	= "DROP TABLE wa_log"; 
$sql_drop[]	= "DROP TABLE wa_log_files"; 
$sql_drop[]	= "DROP TABLE wa_session"; 

$supported_db = array(
	'mysql' => array(
		'Name' => 'MySQL 3.x', 
		'prefixe_file' => 'mysql', 
		'delimiter' => ';', 
		'delimiter2' => ';'
	), 
	'mysql4' => array(
		'Name' => 'MySQL 4.x', 
		'prefixe_file' => 'mysql', 
		'delimiter' => ';', 
		'delimiter2' => ';'
	),
	'mssql' => array(
		'Name' => 'SQL Server', 
		'prefixe_file' => 'mssql', 
		'delimiter' => 'GO', 
		'delimiter2' => ';'
	),
	'postgre' => array(
		'Name' => 'Postgre SQL', 
		'prefixe_file' => 'postgre', 
		'delimiter' => ';', 
		'delimiter2' => ';'
	)
); 

//
// Version de php sous forme d'entier 
// Vu dans defines_php.lib.php de phpMyAdmin 2.5.0-rc1
//
if( preg_match('/([0-9]{1,2})\.([0-9]{1,2})(?:\.([0-9]{1,2}))/', phpversion(), $match) )
{
	$num = 0; 
	
	if( isset($match) )
	{
		if( !isset($match[3]) )
		{
			$match[3] = 0; 
		}
		
		$num = (int) sprintf('%d%02d%02d', $match[1], $match[2], $match[3]); 
	}
}

define('WA_PHP_VERSION', $num); 
unset($num); 

if( WA_PHP_VERSION >= 40100 )
{
	$_ENV	 = $HTTP_ENV_VARS; 
	$_GET	 = $HTTP_GET_VARS; 
	$_POST	 = $HTTP_POST_VARS; 
	$_FILES  = $HTTP_POST_FILES; 
	$_COOKIE = $HTTP_COOKIE_VARS; 
	$_SERVER = $HTTP_SERVER_VARS; 
}

function query_error($query)
{
	global $db, $lang, $template; 
	
	$template->assign_block_vars('result', array(
		'TITLE' => '<span style="color: #FF3333">' . $lang['Title']['error'] . '</span>',
		'MSG_RESULT' => nl2br(sprintf($lang['Error_in_install'], $db->sql_error['message'], $query))
	));
	
	$template->pparse('body');
	exit;
}

require($waroot . 'includes/functions.php'); 

//
// Dsactivation de magic_quotes_runtime + 
// magic_quotes_gpc et ajout ventuel des backslashes 
//
set_magic_quotes_runtime(0); 

if( !get_magic_quotes_gpc() )
{
	emul_magic_quotes_gpc($_GET); 
	emul_magic_quotes_gpc($_POST); 
	emul_magic_quotes_gpc($_COOKIE); 	
}

$vararray = array('start', 'confirm', 'send_file'); 
foreach( $vararray AS $varname )
{
	$$varname = ( isset($_POST[$varname]) ) ? true : false; 
}

$vararray = array(
	'language', 'prev_language', 'type', 'dbtype', 'dbhost', 'dbuser', 'dbpassword', 'dbname', 
	'prefixe', 'admin_login', 'admin_email', 'admin_pass', 'confirm_pass', 'urlsite', 'urlscript'
); 
foreach( $vararray AS $varname )
{
	$$varname = ( !empty($_POST[$varname]) ) ? trim($_POST[$varname]) : ''; 
}

if( @file_exists($waroot . 'includes/config.inc.php') )
{
	include($waroot . 'includes/config.inc.php'); 
}

$dbtype	  		= ( $dbtype != '' ) ? $dbtype : 'mysql'; 
$prefixe  		= ( $prefixe != '' ) ? $prefixe : 'wa_'; 
$confirm_pass 	= ( $confirm_pass != '' ) ? md5($confirm_pass) : ''; 
$language 		= ( $language != '' ) ? $language : $default_lang; 

if( isset($supported_db[$dbtype]) )
{
	include($waroot . 'sql/' . $dbtype . '.php'); 
}
else
{
	die('Le type de base de donnes n\'est pas dfini !'); 
}

require($waroot . 'includes/constantes.php'); 
require($waroot . 'includes/template.php'); 

if( $type != 'reinstall' && $type != 'update' )
{
	$type = 'install'; 
}

if( $type == 'install' && $language != $prev_language )
{
	$start = false;
}

$lang = $datetime = array(); 
$error = false; 
$msg_error = array(); 

$template = new Template($waroot . 'templates/admin/'); 

$template->set_filenames( array(
	'body' => 'install.tpl'
));	

if( defined('NL_INSTALLED') )
{
	$db = new sql($dbhost, $dbuser, $dbpassword, $dbname);
	
	if( !$db->connect_id )
	{
		$error = true; 
		$msg_error[] = '<b>Impossible de se connecter  la base de donnes</b>'; 
	}
	
	$sql = "SELECT language FROM " . CONFIG_TABLE; 
	if( !($result = $db->query($sql)) )
	{
		die('Impossible d\'obtenir la configuration du script'); 
	}
	
	$old_config = $db->fetch_array($result); 	
	$language = $old_config['language']; 
	
	include($waroot . 'language/lang_' . $language . '.php'); 
	
	if( $confirm )
	{
		$sql = "SELECT admin_email, admin_pwd, admin_level 
			FROM " . ADMIN_TABLE . " 
			WHERE LOWER(admin_login) = '" . strtolower($admin_login) . "'"; 
		if( $result = $db->query($sql) )
		{
			if( $row = $db->fetch_array($result) )
			{
				if( md5($admin_pass) == $row['admin_pwd'] && $row['admin_level'] == ADMIN )
				{
					$start 			 = TRUE; 
					$admin_email 	 = $row['admin_email']; 
					$admin_pass_conf = $row['admin_pwd']; 
				}
			}
		}
		
		if( !$start )
		{
			$error = TRUE; 
			$msg_error[] = $lang['Message']['Error_login']; 
		}
	}
	
	$template->assign_vars( array(
		'PAGE_TITLE' => $lang['Title']['update'],
		'S_CHARSET' => $lang['CHARSET'],
		'NEW_VERSION' => $new_version,
		'TRANSLATE' => ( $lang['TRANSLATE'] != '' ) ? ' | Translate by ' . $lang['TRANSLATE'] : ''
	));	
	
	if( !$start )
	{
		$template->assign_block_vars('reinstall', array(
			'L_EXPLAIN_REINSTALL' => nl2br($lang['Warning_reinstall']),
			'L_LOGIN' => $lang['Login'],
			'L_PASS' => $lang['Password'],
			'L_SELECT_TYPE' => $lang['Select_type'],
			'L_TYPE_REINSTALL' => $lang['Type_reinstall'],
			'L_TYPE_UPDATE' => $lang['Type_update'],
			'L_CONF_BUTTON' => $lang['Button']['conf']
		)); 
		
		if( $error )
		{
			$template->assign_block_vars('reinstall.error', array(
				'MSG_ERROR' => '<br /><ul type="square"><li>' . implode('</li><li>', $msg_error) . '</li></ul>'
			)); 
		}
		
		$template->pparse('body'); 
		exit;
	}
}
else
{
	if( $start )
	{
		$db = new sql($dbhost, $dbuser, $dbpassword, $dbname);
		
		if( !$db->connect_id )
		{
			$error = TRUE; 
			$msg_error[] = '<b>Impossible de se connecter  la base de donnes</b>'; 
		}
	}
	
	include($waroot . 'language/lang_' . $language . '.php'); 
	
	$template->assign_vars( array(
		'PAGE_TITLE' => $lang['Title']['install'],
		'S_CHARSET' => $lang['CHARSET'],
		'NEW_VERSION' => $new_version,
		'TRANSLATE' => ( $lang['TRANSLATE'] != '' ) ? ' | Translate by ' . $lang['TRANSLATE'] : ''
	));	
}

$config_file  = '<' . "?php \n\n";
$config_file .= "//\n";
$config_file .= "// Paramtres d'accs  la base de donnes \n";
$config_file .= "// Ne pas modifier ! \n";
$config_file .= "//\n"; 
$config_file .= "define('NL_INSTALLED', true);\n\n"; 
$config_file .= "\$dbtype = \"$dbtype\"; \n\n";
$config_file .= "\$dbhost = \"$dbhost\"; \n";
$config_file .= "\$dbuser = \"$dbuser\"; \n";
$config_file .= "\$dbpassword = \"$dbpassword\"; \n";
$config_file .= "\$dbname = \"$dbname\"; \n\n";
$config_file .= "\$prefixe = \"$prefixe\"; \n\n";
$config_file .= '?' . '>'; 

if( $send_file )
{
	header('Content-Type: text/x-delimtext; name="config.php"'); 
	header('Content-disposition: attachment; filename=config.php'); 
	header('Content-Description: File Transfert'); 
	header('Pragma: no-cache'); 
	header('Expires: 0'); 
	
	
	
	echo $config_file; 
	exit; 
}
else
{
	if( $start )
	{
		include($waroot . 'includes/functions.validate.php'); 
		
		if( $dbhost == '' || $dbname == '' || $dbuser == '' || $prefixe == '' || $admin_login == '' )
		{
			$error = TRUE; 
			$msg_error[] = $lang['Message']['fields_empty']; 
		}
		
		if( !preg_match('/^[[:alnum:]_-]{5,30}$/', $admin_pass) )
		{
			$error = TRUE; 
			$msg_error[] = $lang['Message']['Alphanum_pass']; 
		}
		else if( md5($admin_pass) != $confirm_pass )
		{
			$error = TRUE; 
			$msg_error[] = $lang['Message']['Bad_confirm_pass']; 
		}
		
		$resultat = check_email($admin_email); 
		
		if( $resultat['error'] )
		{
			$error = TRUE; 
			$msg_error[] = $resultat['message']; 
		}
		
		$urlsite = preg_replace('/^http(s)?:\/\/(.*?)\/?$/i', 'http\\1://\\2', $urlsite); 
		
		if( $urlscript != '/' )
		{
			$urlscript = preg_replace('/^\/?(.*?)\/?$/i', '/\\1/', $urlscript); 
		}
		
		//
		// On allonge le temps maximum d'execution du script. 
		//			
		@set_time_limit(1200); 
		
		if( ( $type == 'install' || $type == 'reinstall' ) && !$error )
		{
			if( $type == 'reinstall' )
			{
				$sql_drop = preg_replace('/wa_/', $prefixe, $sql_drop); 
				
				foreach( $sql_drop AS $query )
				{
					$db->query($query); 
				}
			}
			
			$sql_create = $waroot . 'setup/schemas/' . $supported_db[$dbtype]['prefixe_file'] . '_tables.sql'; 
						
			$content = fread(fopen($sql_create, 'r'), filesize($sql_create)); 			
			$sql_create = make_sql_ary($content, $supported_db[$dbtype]['delimiter'], $prefixe); 
			
			foreach( $sql_create AS $query )
			{
				if( !$db->query($query) )
				{
					query_error($query); 
				}
			}
			
			$sql_data	= $waroot . 'setup/schemas/' . $supported_db[$dbtype]['prefixe_file'] . '_data.sql'; 
			
			$content = fread(fopen($sql_data, 'r'), filesize($sql_data)); 			
			$sql_data = make_sql_ary($content, $supported_db[$dbtype]['delimiter2'], $prefixe); 
			
			foreach( $sql_data AS $query )
			{
				if( !$db->query($query) )
				{
					query_error($query); 
				}
			}
			
			$sql_data = array(); 
			$sql_data[] = "UPDATE " . ADMIN_TABLE . " SET admin_login = '" . $admin_login . "', admin_pwd = '" . md5($admin_pass) . "', admin_email = '$admin_email', admin_lang = '$language' WHERE admin_id = 1"; 
			$sql_data[] = "UPDATE " . CONFIG_TABLE . " SET urlsite = '$urlsite', path = '$urlscript', language = '$language', mailing_startdate = " . time() . ", version = '$new_version'"; 
			
			foreach( $sql_data AS $query )
			{
				if( !$db->query($query) )
				{
					query_error($query); 
				}
			}
		}
		else if( $type == 'update' && !$error )
		{
			
			die('Pour mettre  jour une version 2.0.x ou 2.1.x, utilisez le fichier <a href="update.php">update.php</a>'); 
			
		}// end if update
		
		$db->close_connexion();	
		
		if( !$error )
		{
			$l_title = ( $type == 'install' || $type == 'reinstall' ) ? $lang['Result_install'] : $lang['Result_update']; 
			
			if( $type == 'install' )
			{
				if( !($fw = @fopen($waroot . 'includes/config.inc.php', 'w')) )
				{
					$s_hidden_fields  = '<input type="hidden" name="dbtype" value="' . $dbtype . '" />'; 
					$s_hidden_fields .= '<input type="hidden" name="dbhost" value="' . $dbhost . '" />'; 
					$s_hidden_fields .= '<input type="hidden" name="dbuser" value="' . $dbuser . '" />'; 
					$s_hidden_fields .= '<input type="hidden" name="dbpassword" value="' . $dbpassword . '" />'; 
					$s_hidden_fields .= '<input type="hidden" name="dbname" value="' . $dbname . '" />'; 
					$s_hidden_fields .= '<input type="hidden" name="prefixe" value="' . $prefixe . '" />'; 
					
					$template->assign_block_vars('download_file', array(
						'L_TITLE' => $l_title,
						'L_DL_BUTTON' => $lang['Button']['dl'],
						
						'MSG_RESULT' => nl2br($lang['Success_whithout_config']),						
						'S_HIDDEN_FIELDS' => $s_hidden_fields
					));
					
					$template->pparse('body'); 
					exit;
				}
				
				fwrite($fw, $config_file);
				fclose($fw);
			}
			
			$msg_result = ( $type == 'install' || $type == 'reinstall' ) ? $lang['Success_install'] : $lang['Success_update']; 
			
			$template->assign_block_vars('result', array(
				'L_TITLE' => $l_title,
				'MSG_RESULT' => nl2br(sprintf($msg_result, '<a href="' . $waroot . 'admin/login.php">', '</a>'))
			));
			
			$template->pparse('body'); 
			exit;
		}
	}
	
	include($waroot . 'includes/functions.box.php'); 
	$lang_box = lang_box($language); 
	
	$lg = strtolower(substr($language, 0, 2)); 
	if( $lg != 'fr' && $lg != 'en' )
	{
		$lg = 'en'; 
	}
	
	$db_box = '<select name="dbtype">'; 
	foreach( $supported_db AS $db_name => $db_infos )
	{
		$selected = ( $dbtype == $db_name ) ? ' selected="selected"' : ''; 
		$db_box .= '<option value="' . $db_name . '"' . $selected . '> - ' . $db_infos['Name'] . ' - </option>'; 
	}
	$db_box .= '</select>'; 
	
	if( $urlsite == '' )
	{
		$urlsite = ( !empty($_SERVER['HTTP_HOST']) ) ? 'http://' . $_SERVER['HTTP_HOST'] : ''; 
	}
	
	if( $urlscript == '' )
	{
		$urlscript = ( !empty($_SERVER['PHP_SELF']) ) ? preg_replace('/^(.*?)\/setup\/?$/i', '\\1/', dirname($_SERVER['PHP_SELF'])) : ''; 
	}
	
	$template->assign_block_vars('welcome', array(
		'L_WELCOME' => nl2br( sprintf($lang['Welcome_in_install'], '<a href="' . $waroot . 'docs/readme_' . $lg . '.html" target="_blank">', '</a>')), 
		'TITLE_DATABASE' => $lang['Title']['database'],
		'TITLE_ADMIN' => $lang['Title']['admin'],
		'TITLE_DIVERS' => $lang['Title']['config_divers'],
		'L_DBTYPE' => $lang['dbtype'],
		'L_DBHOST' => $lang['dbhost'],
		'L_DBNAME' => $lang['dbname'],
		'L_DBUSER' => $lang['dbuser'],
		'L_DBPWD' => $lang['dbpwd'],
		'L_PREFIXE' => $lang['prefixe'],
		'L_DEFAULT_LANG' => $lang['Default_lang'],
		'L_LOGIN' => $lang['Login'],
		'L_PASS' => $lang['Password'],
		'L_PASS_CONF' => $lang['Conf_pass'],
		'L_EMAIL' => $lang['Email_address'],
		'L_URLSITE' => $lang['Urlsite'],
		'L_URLSCRIPT' => $lang['Urlscript'],
		'L_URLSITE_NOTE' => $lang['Urlsite_note'],
		'L_URLSCRIPT_NOTE' => $lang['Urlscript_note'],
		'L_BUTTON_START' => $lang['Start_install'],
		
		'DB_BOX' => $db_box,
		'DBHOST' => htmlspecialchars(stripslashes($dbhost)),
		'DBNAME' => htmlspecialchars(stripslashes($dbname)),
		'DBUSER' => htmlspecialchars(stripslashes($dbuser)),
		'DBPWD' => htmlspecialchars(stripslashes($dbpassword)),
		'PREFIXE' => htmlspecialchars(stripslashes($prefixe)),
		'LOGIN' => htmlspecialchars(stripslashes($admin_login)),
		'EMAIL' => htmlspecialchars(stripslashes($admin_email)),
		'URLSITE' => htmlspecialchars(stripslashes($urlsite)),
		'URLSCRIPT' => htmlspecialchars(stripslashes($urlscript)),
		
		'LANG_BOX' => $lang_box,
		'S_HIDDEN_FIELD' => '<input type="hidden" name="prev_language" value="' . $language .'" />'
	)); 
	
	if( $error )
	{
		$template->assign_block_vars('welcome.error', array(
			'MSG_ERROR' => '<br /><ul type="square"><li>' . implode('</li><li>', $msg_error) . '</li></ul>'
		)); 
	}
}

$template->pparse('body'); 
?>